package com.nsgk.ruralWeb.utils;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.res.Resources;
import android.net.Uri;
import android.provider.Settings;

public final class NSContextUtils
{
    public static void RequestLocationPermission(Activity context, int requestCode)
    {
        Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
        context.startActivityForResult(intent, requestCode);
    }

    public static void OpenAppSetting(Context context)
    {
        Intent intent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
        Uri uri = Uri.fromParts("package", context.getApplicationContext().getPackageName(), null);
        intent.setData(uri);
        context.startActivity(intent);
    }

    public static String GetAppVersion(Context context)
    {
        String version = "UNKNOWN";
        try
        {
            PackageManager manager = context.getPackageManager();
            PackageInfo info = manager.getPackageInfo(context.getApplicationContext().getPackageName(), 0);
            version = info.versionName;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return version;
    }

    public static boolean BuildIsDebug(Context context)
    {
        try
        {
            ApplicationInfo info = context.getApplicationInfo();
            return (info.flags & ApplicationInfo.FLAG_DEBUGGABLE) != 0;
        }
        catch (Exception e)
        {
            e.printStackTrace();
            return false; // default is release
        }
    }

    public static String GetListName(Context context, String value, int keyResource, int nameResource, String... def)
    {
        Resources resources = context.getResources();
        String[] keys = resources.getStringArray(keyResource);
        String[] names = resources.getStringArray(nameResource);

        for(int i = 0; i < keys.length; i++)
        {
            if(keys[i].equals(value))
                return names[i];
        }
        return null != def && def.length > 0 ? def[0] : null;
    }

    public static String tr(Context context, int id, Object...args)
    {
        return context.getResources().getString(id, args);
    }

    private NSContextUtils() {}
}
